#
# Conditional build:
%bcond_with	default_crypt	# build as default libcrypt provider

Summary:	Crypt Library for DES, MD5, and Blowfish
Summary(pl.UTF-8):	Biblioteka szyfrująca hasła obsługująca DES, MD5 i Blowfish
Name:		libxcrypt
Version:	4.4.25
Release:	1
License:	LGPL v2.1+
Group:		Libraries
#Source0Download: https://github.com/besser82/libxcrypt/releases
Source0:	https://github.com/besser82/libxcrypt/archive/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	4828b1530f5bf35af0b45b35acc4db1d
Patch0:		%{name}-xcrypt.patch
URL:		https://github.com/besser82/libxcrypt
BuildRequires:	autoconf >= 2.62
BuildRequires:	automake >= 1:1.14
BuildRequires:	gcc >= 5:3.2
BuildRequires:	libltdl-devel
BuildRequires:	libtool >= 2:2
BuildRequires:	pkgconfig >= 1:0.27
%if %{with default_crypt}
Provides:	crypt(blowfish)
Obsoletes:	glibc-libcrypt
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%undefine	__cxx

%if %{with default_crypt}
%define		libname		libcrypt
%define		libver		1
%else
%define		libname		libxcrypt
%define		libver		2
%endif


%description
libxcrypt is a replacement for libcrypt, which comes with the GNU C
Library. It supports DES crypt, MD5, and passwords with Blowfish
encryption.

%description -l pl.UTF-8
libxcrypt to zamiennik biblioteki libcrypt dostarczanej wraz z
biblioteką GNU C (libc). Obsługuje szyfrowanie haseł DES, MD5 oraz
Blowfish.

%package devel
Summary:	Header file for libxcrypt
Summary(pl.UTF-8):	Plik nagłówkowy biblioteki libxcrypt
License:	LGPL v2.1+
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
This package contains the header file to develop software using
libxcrypt.

%description devel -l pl.UTF-8
Ten pakiet zawiera plik nagłówkowy pozwalający na tworzenie programów
korzystających z libxcrypt.

%package static
Summary:	Static libxcrypt library
Summary(pl.UTF-8):	Statyczna biblioteka libxcrypt
License:	LGPL v2.1+
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
This package contains the static libxcrypt library used for
development.

%description static -l pl.UTF-8
Ten pakiet zawiera statyczną wersję biblioteki libxcrypt.

%prep
%setup -q
%{!?with_default_crypt:%patch0 -p1}

%build
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__autoheader}
%{__automake}
%configure \
	%{!?with_default_crypt:--includedir=%{_includedir}/xcrypt} \
	--disable-werror \
	--disable-xcrypt-compat-files
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/%{_lib}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%{__mv} $RPM_BUILD_ROOT%{_libdir}/%{libname}.so.* $RPM_BUILD_ROOT/%{_lib}
ln -snf /%{_lib}/$(basename $RPM_BUILD_ROOT/%{_lib}/%{libname}.so.*.*.*) $RPM_BUILD_ROOT%{_libdir}/%{libname}.so

# obsoleted by pkg-config
%{__rm} $RPM_BUILD_ROOT%{_libdir}/%{libname}.la
# PLD doesn't need Owl compatibility
%{__rm} $RPM_BUILD_ROOT%{_libdir}/libowcrypt.*
# packaged with glibc-devel
%{!?with_default_crypt:%{__rm} $RPM_BUILD_ROOT%{_mandir}/man3/crypt{,_r,_ra,_rn}.3*}

%clean
rm -rf $RPM_BUILD_ROOT

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog LICENSING NEWS README.md THANKS TODO.md
%attr(755,root,root) /%{_lib}/%{libname}.so.*.*.*
%attr(755,root,root) %ghost /%{_lib}/%{libname}.so.%{libver}

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/%{libname}.so
%if %{with default_crypt}
%{_includedir}/crypt.h
%else
%{_includedir}/xcrypt
%endif
%{_pkgconfigdir}/libcrypt.pc
%{_pkgconfigdir}/libxcrypt.pc
%{_mandir}/man3/crypt_checksalt.3*
%{_mandir}/man3/crypt_gensalt*.3*
%{_mandir}/man3/crypt_preferred_method.3*
%if %{with default_crypt}
%{_mandir}/man3/crypt.3*
%{_mandir}/man3/crypt_r.3*
%{_mandir}/man3/crypt_ra.3*
%{_mandir}/man3/crypt_rn.3*
%endif
%{_mandir}/man5/crypt.5*

%files static
%defattr(644,root,root,755)
%{_libdir}/%{libname}.a
%changelog
* Sat Aug 14 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/libxcrypt.git;a=log;h=master

* Fri Aug 13 2021 Jan Palus <atler@pld-linux.org> fee2e5f
- up to 4.4.25

* Wed Aug 04 2021 Jan Palus <atler@pld-linux.org> 8a0e07d
- up to 4.4.24

* Mon Jun 21 2021 Jan Palus <atler@pld-linux.org> 496a9cf
- up to 4.4.23

* Thu Jun 10 2021 Jan Palus <atler@pld-linux.org> f35557c
- up to 4.4.22

* Tue Apr 13 2021 Jan Palus <atler@pld-linux.org> 44a6006
- up to 4.4.19

* Fri Feb 26 2021 Jakub Bogusz <qboosh@pld-linux.org> e0e7ded
- updated xcrypt patch

* Thu Feb 25 2021 Jan Palus <atler@pld-linux.org> 4e11022
- up to 4.4.18

* Sun Oct 25 2020 Jakub Bogusz <qboosh@pld-linux.org> 39d43e4
- explicit /usr/include/*.h files (in default_crypt case)

* Sun Oct 25 2020 Jan Palus <atler@pld-linux.org> f7f4363
- don't customize _includedir when building as default crypt

* Mon Aug 24 2020 Jan Palus <atler@pld-linux.org> 0f4884b
- add bcond for building as libcrypt replacement

* Sun Aug 23 2020 Jakub Bogusz <qboosh@pld-linux.org> 53a124c
- updated to 4.4.17
- updated xcrypt patch

* Sat Oct 05 2019 Jakub Bogusz <qboosh@pld-linux.org> c6198b7
- updated to 4.4.10
- updated xcrypt patch
- removed obsolete Add-x32-specific-inline-asm patch

* Mon Jan 28 2019 Adam Gołębiowski <adamg@pld-linux.org> 35b5b7a
- release 2, x32 buildfix

* Fri Nov 30 2018 Jakub Bogusz <qboosh@pld-linux.org> eee95ac
- packages already linked with libxcrypt.so.2 need glibc compatibility API (e.g. pam)

* Fri Nov 30 2018 Jakub Bogusz <qboosh@pld-linux.org> c311c83
- updated to 4.4.0
- removed outdated noWerror,libc-lock,link patches
- added xcrypt patch (still install as libxcrypt, not glibc libcrypt replacement)

* Mon Apr 10 2017 Jakub Bogusz <qboosh@pld-linux.org> dd0823f
- new URLs, updated to 3.1.1 (now includes crypt_blowfish 1.3)
- updated noWerror patch
- added link patch

* Tue Feb 24 2015 Jan Rękorajski <baggins@pld-linux.org> 3025189
- x32 rebuild
- release 3 (by relup.sh)

* Mon Feb 04 2013 Marcin Banasiak <marcin.banasiak@gmail.com> 475fb14
- Fix build with glibc >= 2.16 (patch from debian)

* Tue Jun 19 2012 Jacek Konieczny <jajcus@pld-linux.org> 6329dab
- disable -Werror from CFLAGS or this code won't compile under modern gcc

* Fri Jul 09 2010 Jakub Bogusz <qboosh@pld-linux.org> e65f8c9
- added pl, more verbose files, check-files cleanup

